# Author: Zeynep G. Saribatur
# 29 Jan 2021: - calls diverse sets of "in"
#              - aims for achieving faithful abstractions w.r.t. in - thus looks at all abs answer sets and refines if "ab" occurs during a check
#              - fixed a bit the issue with having refinefocus but still picking random refines TODO need to be made better
#


import sys
import os, glob
import subprocess
import time
import re
import random
from random import randint
import itertools
import csv

import time

			
'''def checkFile(sets,logFile):
	arr=[]
	#print(sets)
	for i in range(0,len(sets)):
		checkfile=open(test+ '_check_answer'+str(i), 'w')
		logFile.write("In file "+ test+ "_check_answer"+str(i)+": "+ "\n")
		checkfile.write("%"+ sets[i])
		logFile.write("%"+ sets[i])
		sets[i]=sets[i][:sets[i].find("\n")]
		arr=sets[i].split(' ')
		checkfile.write("\n")
		logFile.write("\n")
		for j in range(0, len(arr)):
			if arr[j].find("mapTo")==-1 and arr[j].find("_")!=0 and arr[j].find("geq")==-1 and arr[j].find("less")==-1 and arr[j].find("equ")==-1 and arr[j].find("neq")==-1 and arr[j].find("leq")==-1:
				checkfile.write("absexists("+ arr[j] + "). ")
				logFile.write("absexists("+ arr[j] + "). ")
		checkfile.close()	
		logFile.write("\n")

	logFile.write("\n Step4 is done." + "\n")		
	logFile.write("\n")'''
	
def createCheckFile(sets,logFile):

	arr=[]
	#print(sets)
	for i in range(0,len(sets)):
		checkfile=open(test+ '_check_answer'+str(i), 'w')
		logFile.write("In file "+ test+ "_check_answer"+str(i)+": "+ "\n")
		checkfile.write("%"+ sets[i])
		logFile.write("%"+ sets[i])
		#sets[i]=sets[i][:sets[i].find("\n")]
		arr=sets[i].split(', ')
		checkfile.write("\n")
		logFile.write("\n")
		for j in range(0, len(arr)):
			if arr[j].find("mapTo")==-1 and arr[j].find("_")!=0 and arr[j]!="" and arr[j].find("geq")==-1 and arr[j].find("less")==-1 and arr[j].find("equ")==-1 and arr[j].find("neq")==-1 and arr[j].find("leq")==-1:
				checkfile.write("absexists("+ arr[j] + "). ")
				logFile.write("absexists("+ arr[j] + "). ")
		checkfile.close()	
		logFile.write("\n")

	logFile.write("\n Step4 is done." + "\n")		
	logFile.write("\n")
	

def testIfIndeedHasSolution(test,logFile):
	clingo = subprocess.Popen(
			"clingo {} ".format(test + ' aux_binaryrelations.lp aux_nonbinaryrelations.lp'),# ../grid-cell_abstraction/ricochet_robots/Encodings/ASP/small/addDir6args8.txt'),
			 shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
	clingoout, clingoerr = clingo.communicate()
	clingo.wait()
	del clingo
	clingoout = clingoout.decode('utf-8')
	if clingoout.find('UNSATISFIABLE') != -1:
		print("PROGRAM IS ACTUALLY UNSAT")
		logFile.write("PROGRAM IS ACTUALLY UNSAT\n")
		sys.exit()
		
def callClingoForDebugging(i,outputFile,temp,test,mapping,logFile):
	#global mainlog
	global writer
	global index

	logFile.write("Clingo is called with: "+ outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+ " aux_binaryrelations.lp aux_nonbinaryrelations.lp aux_absregionfacts.lp\n")# ../grid-cell_abstraction/ricochet_robots/Encodings/ASP/small/addDir6args8.txt\n")
	t=time.clock()
	#print "calling clingo"
	clingo = subprocess.Popen(
	#"clingo {} ".format(outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+' aux_binaryrelations.lp aux_nonbinaryrelations.lp'),
		"clingo {} ".format(outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+' aux_binaryrelations.lp aux_nonbinaryrelations.lp aux_absregionfacts.lp'),# ../grid-cell_abstraction/ricochet_robots/Encodings/ASP/small/addDir6args8.txt'),
		 shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
	clingoout, clingoerr = clingo.communicate()
	clingo.wait()
	#print "wait is over?"
	#print(clingoout)
	del clingo
	clingoout = clingoout.decode('utf-8')
	#print(clingoout)
	
	#TODO dont write all the output only the last answer, if exists!
	#logFile.write("Clingo output is: " + "\n")
	#logFile.write(clingoout)
	#logFile.write("\n")
	
	elapsed_time = time.clock() - t
	print(elapsed_time)

	#print "written time"
	#mainlog+="checking at original domain\n"
	#mainlog+="time for checking an abstract answer sets: "+str(elapsed_time)+"\n"
        #mainlog+=clingoout[clingoout.find("CPU Time"):]
	writer[index].append(re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0])
	#FIXME should record time somewhere
	#t=re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0]
	clingoLines=clingoout.split("\n")
	#print clingoLines[len(clingoLines)-10:]
	for k in range (0, len(clingoLines)):
		if clingoLines[k].find("UNSATISFIABLE")!= -1:
			print("ANSWER IS UNSATISFIABLE, quitting...")
			sys.exit()
		if clingoLines[k].find("OPTIMUM FOUND")!= -1 or clingoLines[k].find("SATISFIABLE")!= -1:
			break
		
	if k==len(clingoLines)-1:
		print("No OPTIMUM FOUND, quitting...")
		sys.exit()
	
	if "ab" not in clingoLines[k-2]:
		print("DONE! Found a solution to "+ test)
		logFile.write("DONE! Found a solution to "+ test+"\n\n")
		cost=0
		print("testing the original program!")
		#if the org prog is actually unsat -> exits
		testIfIndeedHasSolution(test,logFile)
		return []
	else:
		abtext=clingoLines[k-2]
		return abtext
            
def debugAnswerToGetCost(test,temp,mapping,onlyanswersets,logFile,refinetype):
	global alloccurringabatoms
	global writer
	global index
    
	cost=[]
	mincost=-1
	#level=0
	abtext=""
	for i in range (0,len(onlyanswersets)):
		logFile.write("Doing the checking for check_answer"+str(i)+"\n")

		

		logFile.write("Running translatorMetaToNonGroundSpock_withoutArg.py " + test+"_input_meta\n")

		p= subprocess.Popen("python translatorMetaToNonGroundSpock_withoutArg.py {} ".format(test+"_input_meta"),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		output, err =p.communicate()
		p.wait()
		
		#creates _input_meta_debug
		outputFile=test+"_input_meta_debug"

		try:
			with open(outputFile) as f:
				f.close()

		except IOError:
			print(outputFile+ " does not exist. ")
			sys.exit()
       
		#logFile.write("Clingo is called with: "+ outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+' aux_binaryrelations.lp aux_nonbinaryrelations.lp'+ "\n")
                
		#abtext=callClingoForDebugging(i,outputFile,temp,test,mapping,logFile)
		# Jan 27'19 - also incrementing for above one
		#if incremental==False:
		#mainlog+="debug without arguments\n"
		abtext=callClingoForDebugging(i,outputFile,temp,test,mapping,logFile)
		#else:
		#        #Jan 21'19 - trying some incremental stuff                    
		#        abtext=incrementalDebugOverTime(i,outputFile,temp,test,mapping,logFile)	
		spamwriter.writerow(writer[index])
		index=index+1
		writer[index].append("")
		writer[index].append("")
		writer[index].append("")
		
		if abtext==[]:
			#return 0
			#12 March 2021 : not returning, since aiming for faithfulness, not one concrete abs ans set
			cost=0
			continue
                    
		deactivatingrules=re.findall(r"ab_deactivated[A-Za-z]*\((\S*)\)",abtext)
		#activatingrules=re.findall(r"ab_activated\((\S*)\)",abtext)
		activatingpreds=re.findall(r"ab_activated\(([A-Za-z0-9\_]*)",abtext)
		if activatingpreds!=[]:
			activatingpreds=list(set(activatingpreds))
		print(deactivatingrules)
		print(activatingpreds) 	
                    
		#if incremental==False:
		#Jan 21'19 - when an incremental debugging is done, doing the debugging with a focus on some rules/preds sometimes returns unsat, 
		#           as they are not enough to find the reason for the spuriousness of only having time=1
		logFile.write("Running translatorMetaToNonGroundSpock.py " + test+"_input_meta "+",".join(deactivatingrules)+" "+",".join(activatingpreds)+"\n")
		p= subprocess.Popen("python translatorMetaToNonGroundSpock.py {} ".format(test+"_input_meta "+",".join(deactivatingrules)+" "+",".join(activatingpreds)+"\n"), shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
                    
		#else:
		#    logFile.write("Running translatorMetaToNonGroundSpock.py " + test+"_input_meta\n")
		#    p= subprocess.Popen("python translatorMetaToNonGroundSpock.py {} ".format(test+"_input_meta"),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
                
		output, err =p.communicate()
		p.wait()
                    
                    
                #creates _input_meta_debug
		outputFile2=test+"_input_meta_debug"
                    
		try:
			with open(outputFile2) as f:
				f.close()

		except IOError:
			print(outputFile2+ " does not exist. ")
			sys.exit()
		#else:
                        
		#if incremental==False:
		#mainlog+="debug with arguments\n"
		abtext=callClingoForDebugging(i,outputFile2,temp,test,mapping,logFile)
		#else:
		#     #Jan 21'19 - trying some incremental stuff                    
		#     abtext=incrementalDebugOverTime(i,outputFile2,temp,test,mapping,logFile)
                       
		if abtext==[]:
			#return 0
			#12 March 2021 : not returning, since aiming for faithfulness, not one concrete abs ans set
			cost=0
			continue                  
                        #print abtext
		if refinetype=="0":
			costnum=abtext.count("ab")
			if mincost==-1 or costnum<mincost:
				mincost=costnum
			cost.append(costnum)
                         
                            
			abtext=abtext.split(" ")
			abtext=[re.findall(r"(\d+)",a) for a in abtext if "refine" not in a]
			abtextnew=[a[1:] for a in abtext]
			#print abtextnew
			abtextnewnew=[list(set(a)) for a in abtextnew]
			#print abtextnewnew
			alloccurringabatoms=abtextnewnew
		else: 
			abtext=abtext.split(" ")
			abtextactivate=[re.findall(r"(\d+)",a) for a in abtext if "refine" not in a and "ab_activated" in a]
			abtextactivate=[a for a in abtextactivate if a!=[]]
			abtextdeactivate=[re.findall(r"(\d+)",a) for a in abtext if "refine" not in a and "ab_activated" not in a]
			abtextdeactivatenew=[a[1:] for a in abtextdeactivate]
			#abtextnewnew=[list(set(a)) for a in abtextnew]
			#print abtextnewnew
			alloccurringabatoms+=abtextactivate+abtextdeactivatenew
			#print "alloccurringabatoms"
			#print alloccurringabatoms
			if alloccurringabatoms!=[]:
				cost=alloccurringabatoms
				break
			else:
				cost=0
			#print("get ref atoms")
			#print(abtext)
			#abtext=abtext.split(" ")
			## Feb 5'19 - trying out refineCount thingy
			##abtext=[tuple(a[a.index("(")+1:a.index(")")].encode('utf-8').split(",")) for a in abtext if "refine(" in a]
			#abtext=[tuple(a[a.index("(")+1:a.index(")")].encode('utf-8').split(",")) for a in abtext if "refineCountMain(" in a]
			##if incremental==True:
				##abtexttemp=[a for a in abtext if a[3]!="1"]
				##if abtexttemp!=[]:
					##abtext=abtexttemp
			#print abtext
			#abtext.sort(key=lambda x: float(int(x[2])/int(x[3])), reverse=True)
			#abtext=[(a[0],a[1]) for a in abtext if float(int(a[2])/(int(a[3])*a[0].count("a")))==float(int(abtext[0][2])/(int(abtext[0][3])*abtext[0][0].count("a")))]
			##abtext=[(a[0],a[1]) for a in abtext if float(int(a[2])/int(a[3]))==float(int(abtext[0][2])/int(abtext[0][3]))]
			#abtext.sort(key=lambda x: len(x[0])*len(x[1]))
			#abtext=[(a[0],a[1]) for a in abtext if a[0].count("a")*a[1].count("b")==abtext[0][0].count("a")*abtext[0][1].count("b")]
			#print(abtext)
			#cost+=abtext
		#aa=raw_input("aaa")
	print(cost)
	if refinetype=="0":
		cost=[mincost]
	return cost

def getCostOfMapping(test,mapping,pred,interestedelts,writer,index):
	global alloccurringabatoms
	logFile=open('log_search.txt','w')

	logFile.write("Running python program_dom_abstraction_v2.py "+ test + ' ' + mapping + ' ' + pred + "\n")

	if interestedelts!=[]:		
		p= subprocess.Popen("python program_dom_abstraction_v2.py {} ".format(test+ ' ' + mapping + ' ' + pred + ' '+interestedelts),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		output, err =p.communicate()
		p.wait()
	
	
		logFile.write("Running python program_dom_abstraction_v2.py "+ test + ' ' + mapping + ' ' + pred + ' '+interestedelts+ "\n")
	else:
		p= subprocess.Popen("python program_dom_abstraction_v2.py {} ".format(test+ ' ' + mapping + ' ' + pred),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		output, err =p.communicate()
		p.wait()
	
	temp=test+"_input"


	if os.path.isfile(temp)==True:
		temp1=test+"_input_abs"
		temp2=test+"_input_absfacts"
	else:
		temp=test
		temp1=test+"_abs"
		temp2=test+"_absfacts"

	logFile.write("Outputs: "+ temp1 + ' '+ temp2 + "\n")
	logFile.write("\n")

	try:
		with open(temp1) as f:
			f.close()
	except IOError:
		print(temp1+ " does not exist. ")

	else:
		diversitycallscript="simple_diverse_ans_sets.py" 
		logFile.write("Running "+diversitycallscript+" "+interestedelts+" "+ temp1 + " "+ temp2 + " "+ mapping+ "\n")
		t = time.clock()
                clingo = subprocess.Popen(
				"python {} ".format(diversitycallscript+" "+interestedelts+" "+ temp1 + " "+ temp2 + " "+mapping+" 0"),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		#clingo = subprocess.Popen(
		#	"clingo {} ".format(temp1+' '+temp2+' '+mapping +' 37'),  # NEW 28 Jan 2021 added looking at multiple answer sets but of course not nice
		#	shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		clingoout, clingoerr = clingo.communicate()
		#print(clingoout)
		del clingo
		clingoout = clingoout.decode('utf-8')
		#print (clingoout)
		#logFile.write("Clingo is called with: "+ temp1 + ' '+ temp2 + ' '+ mapping+ " 37 \n") # NEW 28 Jan 2021 added looking at multiple answer sets but of course not nice
		logFile.write("Clingo output is: " + "\n")
		logFile.write(clingoout)
		logFile.write("Step2 is done." + "\n")
		logFile.write("\n")

		#t=re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0]
		elapsed_time = time.clock() - t
		#writer[index].append(t)
		writer[index].append(elapsed_time)

		if clingoout.find('UNSATISFIABLE') != -1 or clingoout.find('displayed 0 answer sets') != -1:
			print(test+" is unsatisfiable!")
			writer[index].append("-")
			writer[index].append("-")
			writer[index].append("UNSAT")
			print("testing the original program!")
			clingo = subprocess.Popen(
					"clingo {} ".format(test + ' aux_binaryrelations.lp aux_nonbinaryrelations.lp'),
					 shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
			clingoout, clingoerr = clingo.communicate()
			del clingo
			clingoout = clingoout.decode('utf-8')
			if clingoout.find('UNSATISFIABLE') == -1:
				print "PROGRAM IS ACTUALLY NOT UNSAT"
				logFile.write("PROGRAM IS ACTUALLY NOT UNSAT\n")
				sys.exit()
			t=re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0]			
			writer[index].append(t)
			return -1
			#sys.exit()
		
		#answersets=re.findall(r"(.*\n)", clingoout)

		#for i in range (0,len(answersets)):
		#	if answersets[i]== "Answer: 1\n":
		#		start=i
		#	elif answersets[i]== "SATISFIABLE\n":
		#		end=i
		#onlyanswersets=[answersets[k] for k in range(start+1,end) if "Answer:" not in answersets[k]]		
		onlyanswersets=re.findall(r"INTERESTINGTRUE \[(.*)\]", clingoout)
		createCheckFile(onlyanswersets,logFile)
		
		
		cost=debugAnswerToGetCost(test,temp,mapping,onlyanswersets,logFile,refinetype)
		
		
		##logFile.write("Running python not_ab_atoms_new.py " + test+' '+pred + ' time'+"\n")
		#logFile.write("Running python not_ab_atoms_new.py " + test+' '+pred +"\n")

		##p= subprocess.Popen("python not_ab_atoms_new.py {} ".format(test+' '+pred + ' time'),
		#p= subprocess.Popen("python not_ab_atoms_new.py {} ".format(test+' '+pred),
			#shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		#output, err =p.communicate()
		#p.wait()

		##time.sleep(1)
		#outputFile=test+"_ab"
		#logFile.write("Output is: "+ outputFile + "\n")
		#logFile.write("Step5 is done." + "\n")
		#logFile.write("\n")

		#try:
			#with open(outputFile) as f:
				#f.close()

		#except IOError:
			#print(outputFile+ " does not exist. ")
			#sys.exit()
		#else:
			#cost=[]
			#for i in range (0,len(onlyanswersets)):
				#logFile.write("Clingo is called with: "+ outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+' aux_binaryrelations.lp aux_nonbinaryrelations.lp'+ "\n")
				#clingo = subprocess.Popen(
					#"clingo {} ".format(outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+' aux_binaryrelations.lp aux_nonbinaryrelations.lp'),
					 #shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
				#clingoout, clingoerr = clingo.communicate()
				##print(clingoout)
				#del clingo
				#clingoout = clingoout.decode('utf-8')
				#allanswers=re.findall(r"Answer: (.*)\n", clingoout)
				#clingoout=clingoout[clingoout.index("Answer: "+allanswers[len(allanswers)-1])::]
				#print(clingoout)
				

				
				#logFile.write("Clingo output is: " + "\n")
				#logFile.write(clingoout)
				#logFile.write("\n")

				
				#t=re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0]

				#clingoLines=clingoout.split("\n")
				#for k in range (0, len(clingoLines)):
					#if clingoLines[k].find("OPTIMUM FOUND")!= -1:
						#break
					#if clingoLines[k].find("UNSATISFIABLE")!= -1:
						#print("ANSWER IS UNSATISFIABLE, quitting...")
						#sys.exit()
			
				#if k==len(clingoLines)-1:
					#print("No OPTIMUM FOUND, quitting...")
					#sys.exit()
			
				#if "ab" not in clingoLines[k-2]:
				##if clingoLines[k-1][-1]=="0" and clingoLines[k-1][-2]==" ":
					#print("DONE! Found a solution to "+ test)
					#logFile.write("DONE! Found a solution to "+ test)
					#writer[index].append("0")
					#writer[index].append(t)
					#writer[index].append("SAT")
					##cost=0  NEW JAN 28 2021: trying something so that it goes through the answer sets until a spurious one is encountered
					#cost.append(0)
					#print("testing the original program!")
					#clingo = subprocess.Popen(
							#"clingo {} ".format(test + ' aux_binaryrelations.lp aux_nonbinaryrelations.lp'),
							 #shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
					#clingoout, clingoerr = clingo.communicate()
					#del clingo
					#clingoout = clingoout.decode('utf-8')
					#if clingoout.find('UNSATISFIABLE') != -1:
						#print "PROGRAM IS ACTUALLY UNSAT"
						#logFile.write("PROGRAM IS ACTUALLY UNSAT\n")
						#sys.exit()
					#t=re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0]			
					#writer[index].append(t)
					##break NEW JAN 28 2021: trying something so that it goes through the answer sets until a spurious one is encountered
				#else:
					#abtext=clingoLines[k-2]
					#costnum=abtext.count("ab")
					#cost.append(costnum)
					#writer[index].append(str(costnum))
					#writer[index].append(t)
					#writer[index].append("-")
					#writer[index].append("-")
					#abtext=abtext.split(" ")
					#abtext=[re.findall(r"(\d+)",a) for a in abtext]
					##print abtext
					#abtextnew=[a[1:] for a in abtext]
					##print abtextnew
					#abtextnewnew=[list(set(a)) for a in abtextnew]
					##print abtextnewnew
					#alloccurringabatoms=abtextnewnew
					#break
						

			#if len([elem for elem in cost if elem != 0])==0:
				#cost=0    
		return cost

def getRemainderCombination(test,arr,step,maxsizeref):
	if step>0:
		minsize=1
	else:
		minsize=len(arr)	
	if maxsizeref!=0:
		maxsize=maxsizeref
	else:
		maxsize=len(arr)
	for a in range(minsize,maxsize+1):
		listing = [list(x) for x in itertools.combinations(arr, a)]
		cameback=False
		#print "listing:"
		#print listing
		for b in range(0, len(listing)):
			test2=test+[listing[b]]
			#print test2
			remarr=[i for i in arr if i not in listing[b]]
			if a==1 and len(remarr)==1:
				test2=test2+[remarr]
				break
			if remarr!=[]:
				#print "vvvvvvvvvvvvvvvv"
				getRemainderCombination(test2,remarr,step-1,0)
				#print "^^^^^^^^^^^^^^^^"
				cameback=True
		if cameback==False:	
			global allprintedtests
			if sorted(test2) not in allprintedtests:
				allprintedtests.append(sorted(test2))
				#print sorted(test2)


def getRemainderSplit(test,arr,step):
	if step>0:
		minsize=1
	else:
		minsize=len(arr)	
	for a in range(minsize,len(arr)+1):
		listing = [arr[:a]]
		cameback=False
		#print "listing:"
		#print listing
		for b in range(0, len(listing)):
			test2=test+[listing[b]]
			#print test2
			remarr=arr[a:]
			if len(remarr)==1:
				test2=test2+[remarr]
				break
			if remarr!=[]:
				#print "vvvvvvvvvvvvvvvv"
				getRemainderSplit(test2,remarr,step-1)
				#print "^^^^^^^^^^^^^^^^"
				cameback=True
		if cameback==False:	
			global allprintedtests
			if sorted(test2) not in allprintedtests:
				allprintedtests.append(sorted(test2))
				#print sorted(test2)

def refineGivenCluster(arr,index,step):
	getRemainderCombination([],arr[index],step,1)
	print "---------------"
	global allprintedtests
	refinesteps=[]
	for j in range(0,len(allprintedtests)):
		refinesteps.append(len(allprintedtests[j])-1)
	for i in range(0,len(arr)):
		if i!=index:
			for j in range(0,len(allprintedtests)):
				allprintedtests[j]=sorted(allprintedtests[j]+[arr[i]])
	print "==========="
	print allprintedtests
	print "refinesteps:"
	print refinesteps
	print "==========="
	#sys.exit()
	return refinesteps


def refineGivenClusterSplit(arr,index,step):
	#print "refine "
	#print arr[index]
	getRemainderSplit([],arr[index],step)
	print "---------------"
	global allprintedtests
	refinesteps=[]
	for j in range(0,len(allprintedtests)):
		refinesteps.append(len(allprintedtests[j])-1)
	for i in range(0,len(arr)):
		if i!=index:
			for j in range(0,len(allprintedtests)):
				allprintedtests[j]=sorted(allprintedtests[j]+[arr[i]])
	print "==========="
	print allprintedtests
	print "refinesteps:"
	print refinesteps
	print "==========="
	return refinesteps

def createMappingFile(arr,filename,maxint,pred):
    
	text="dom("+pred+",1.."+str(maxint)+").\n"
	name=""
	for b in range(0, len(arr)):
		name=name+"_"
		if b<10:
			btemp="0_"+str(b)
		else:
			btemp="_".join(list(str(b)))
		for k in arr[b]:
			#text=text+"mapTo("+str(k)+",a"+str(b)+").\n"
			text=text+"mapTo("+pred+","+str(k)+",a"+str(btemp)+").\n"
			name=name+str(k)+"-"
		name=name[:len(name)-1]
	if filename=="":
		return text
	else:
		fout=open(filename,"w")
		fout.write(text)
		fout.close()

def processText(mappingtext):
	clusters=re.findall(r"\(\w+,(\d+)..(\d+),(\w+)\).",mappingtext)
	singlemaps=re.findall(r"\(\w+,(\d+),(\w+)\).",mappingtext)
	absdom1=list(set([c[2] for c in clusters]))
	absdom2=list(set([s[1] for s in singlemaps]))
	absdoms=sorted(list(set(absdom1+absdom2)))
	clustersAbs=[[] for i in range(len(absdoms))]
	maxint=0
	for c in clusters:
		arr=[]
		for i in range(int(c[0]),int(c[1])+1):
			arr.append(i)
		clustersAbs[absdoms.index(c[2])]+=arr
		if int(c[1])>maxint:
			maxint=int(c[1])
	for s in singlemaps:
		clustersAbs[absdoms.index(s[1])]+=[int(s[0])]
		if int(s[0])>maxint:
			maxint=int(s[0])
	return [clustersAbs,maxint]

def listOfListToText(m):
	text="%["
	for k1 in m:
		text=text+"["
		for k2 in k1:
			text=text+str(k2)+","
		#print text
		text=text[:len(text)-1]+"],"
	text=text[:len(text)-1]+"]\n"	
	return text

def countMostOccElt(arr,maxint):
	occcount=[0]*maxint
	for i in range(1,maxint+1):
		count=sum([x.count(str(i)) for x in arr])
		occcount[i-1]=count
	l = list(enumerate(occcount))
	print l
	sortedl = sorted(l, key=lambda x: -x[1])
	print sortedl
	secondlargest = max([y for (x,y) in sortedl[1:]])
	print secondlargest
	onlylargest = [ (x,y) for (x,y) in sortedl if y >= secondlargest and y!=0] #NEW 28 Jan 2021 added y!=0
	print onlylargest
	if len(onlylargest)>1:
		sampled= random.sample(onlylargest, 2)
		print sampled
		return [sampled[0][0]+1,sampled[1][0]+1]
	else: #NEW 28 Jan 2021 the case of what if there is only one largest!
		return [onlylargest[0][0]+1,onlylargest[0][0]+1]

def existsInSameCluster(arr,focus):
	for a in arr:
		if focus[0] in a and focus[1] in a:
			return True
	return False

def alreadyInDiffClusters(arr,focus):
	for a in arr:
		if focus[0] in a and focus[1] in a:
			return False
	return True
	

def someInSingleCluster(arr,focus):
	if [focus[0]] in arr or [focus[1]] in arr:
		return True
	return False


def allInSingleCluster(arr,focus):
	if [focus[0]] in arr and [focus[1]] in arr:
		return True
	return False

def focusInCluster(arr,focus):
	print "--------checking if focus is here========="
	print arr
	print focus
	if focus[0] in arr or focus[1] in arr:
		return True
	return False

def refineToSingleClusters(arr,focus):
	arrtemp=[]
	for a in arr:
		if focus[0] not in a and focus[1] not in a:
			arrtemp.append(a)
			continue
		elif a==focus[0] or a==focus[1]:
			arrtemp.append(a)
			continue
		else:
			if focus[0] in a:
				temp1=a[:a.index(focus[0])]
				temp2=[focus[0]]
				#12 March 2021 : when making an elt singleton, dont divide the existing cluster
				#temp3=a[a.index(focus[0])+1:]		
				temp1+=a[a.index(focus[0])+1:]
				if temp1!=[]:
					arrtemp.append(temp1)
				arrtemp.append(temp2)
				#if temp3!=[]:
					#arrtemp.append(temp3)
			elif focus[1] in a:
				temp1=a[:a.index(focus[1])]
				temp2=[focus[1]]
				#temp3=a[a.index(focus[1])+1:]
				temp1+=a[a.index(focus[1])+1:]
				if temp1!=[]:
					arrtemp.append(temp1)
				arrtemp.append(temp2)
				#if temp3!=[]:
					#arrtemp.append(temp3)
	return arrtemp
				
	
def computeNewMappingAskedFromUser(filename,test,arr):
    if len(arr)!=1:
        attacksOnArg=raw_input("on which argument (mapped to singleton) and its attackers you want to have more information? (if none, enter 0): ")
        attacksOfArg=raw_input("on which argument (mapped to singleton) and its attacks you want to have more information? (if none, enter 0): ")       
        
        try: 
            int(attacksOnArg)
            int(attacksOfArg)
        except ValueError:
            print("some inputs are wrong!")
            sys.exit()
        
        temp=test+"_input"
        if os.path.isfile(temp)==True:
            temp2=test+"_input_absfacts"
        else:
            temp=test
            temp2=test+"_absfacts"
        
        print("clingo {} ".format(filename+" "+ temp2 + " computenewmapping.lp -c attonarg="+attacksOnArg+" -c attofarg="+attacksOfArg))
        clingo = subprocess.Popen("clingo {} ".format(filename+" "+ temp2 + " computenewmapping.lp -c attonarg="+attacksOnArg+" -c attofarg="+attacksOfArg),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
        clingoout, clingoerr = clingo.communicate()
        del clingo
        clingoout = clingoout.decode('utf-8')
        makesingletons=re.findall(r"makeitsingleton\((\d+)\)",clingoout)
        print makesingletons
        for m in makesingletons:
            newarr= refineToSingleClusters(arr,[int(m),"x"])
            arr=newarr
    else:
        singletonArg=raw_input("which argument you want to have more information about? (if none, enter 0): ")
        try: 
            int(singletonArg)
        except ValueError:
            print("input is wrong!")
            sys.exit()
        newarr= refineToSingleClusters(arr,[int(singletonArg),"x"])
        arr=newarr
        
    return arr
    
test=sys.argv[1]
mapping=sys.argv[2]
pred= sys.argv[3]
refinetype= sys.argv[4]

realfilename=re.findall("([^/]+.lp)",test)[0]

csvfile= open("logfile_localsearch_"+realfilename[:len(realfilename)-3]+"_"+pred+".csv", 'w')
spamwriter=csv.writer(csvfile, delimiter=' ', quoting=csv.QUOTE_MINIMAL)
writer=[[]*8 for x in xrange(1000)]
writer[0].append("Name")
writer[0].append("Step")
writer[0].append("Mapping")
writer[0].append("Abs Answer Computation Time")
writer[0].append("Cost")
writer[0].append("Cost Computation Time")
writer[0].append("Result (Sat/Unsat)")
writer[0].append("Org Computation Time")
spamwriter.writerow(writer[0])


index=1

writer[index].append(realfilename)
writer[index].append("")
writer[index].append("")
writer[index].append("")
writer[index].append("")
writer[index].append("")
writer[index].append("")
spamwriter.writerow(writer[index])
index=index+1
writer[index].append(realfilename)

interestedelts=[]
if len(sys.argv) ==6:
	interestedelts=sys.argv[5]

for filename in glob.glob(test+"_*"):
    os.remove(filename) 

#read mapping from a file with mapTo, convert it to array of arrays
if os.path.isfile(mapping):
	fin=open(mapping,"r")
	mappingtext=fin.read()
	fin.close()
	[mapping,maxint]=processText(mappingtext)
else:
	#mapping=[[1], [2], [3], [4], [5], [6], [7], [8], [9], [10], [11], [12], [13], [14], [15], [16], [17], [18], [19], [20]]
	#mapping=[[1,2,3,4,5,6,7,8,9,10]]
	#mapping=[[1],[2],[3],[4,5,6,7],[8],[9],[10]]
	maxint=10
	arrray=[]
	for i in range(1,maxint+1):
		arrray+=[i]
	mapping=[arrray]
print mapping
print maxint

step=0
writer[index].append(str(step))
writer[index].append(listOfListToText(mapping))

filename="ex/generated_mappings/mapping_init.lp"
createMappingFile(mapping,filename,maxint,pred)
alloccurringabatoms=[]
cost=getCostOfMapping(test,filename,pred,interestedelts,writer,index)
print alloccurringabatoms

alreadyrefined=False

print mapping
print cost

if cost==0 or cost==-1:
	if cost==0:
		answer=raw_input("are you happy with the resulting abstraction? (Y/N):")   
		if answer=="N":
			mapping=computeNewMappingAskedFromUser(filename,test,mapping)  
			print mapping
			refinefocus=[[],[]]
			a=raw_input("will continue with user refinement - press enter")
			alreadyrefined=True
	if not alreadyrefined:
		print("writing mapping to "+test+"_result")
		fout=open(test+"_result","w")
		fout.write(listOfListToText(mapping)+createMappingFile(mapping,"",maxint,pred))
		fout.close()
		sys.exit()
	

if not alreadyrefined:
	refinefocus= countMostOccElt(alloccurringabatoms,maxint)
	print "refinefocus is " + str(refinefocus[0]) + " " +str(refinefocus[1])

a=raw_input("press enter to continue")

spamwriter.writerow(writer[index])
index=index+1
writer[index].append(realfilename)
step=step+1



while True:
	picked=[False]*len(mapping)
	refinecosts=[[] for i in range(len(mapping))]

	allrefinements=[[] for i in range(len(mapping))]

	makesinglecluster=False
	if not alreadyrefined and alreadyInDiffClusters(mapping,refinefocus) and allInSingleCluster(mapping,refinefocus)==False:
		print mapping
#		print refinefocus
		print "not some in single clusters" 
		makesinglecluster=True
		newmapping=refineToSingleClusters(mapping,refinefocus)
		if newmapping!=mapping:
			alreadyrefined=True
			mapping=newmapping
		print mapping
		continue #FIXME this causes for it to again refine???
	#elif alreadyInDiffClusters(mapping,refinefocus)==False:
	#	print mapping
	#	print "in same cluster" 
	#	if refinetype=="0":
	#		refinesteps=refineGivenClusterSplit(mapping,refinefocus,1)
	#	elif refinetype=="1":
	#		refinesteps=refineGivenCluster(mapping,refinefocus,1)
	#	else:
	#		print "give a reasonable refinetype input!"
	#		sys.exit()
	elif refinefocus[0]==refinefocus[1] and existsInSameCluster(mapping,refinefocus) and allInSingleCluster(mapping,refinefocus)==False: #NEW 28 Jan 2021 considering refinefocus to contain same elts
		newmapping=refineToSingleClusters(mapping,refinefocus)   
		if newmapping!=mapping:
			alreadyrefined=True
			mapping=newmapping
		print mapping
		continue #FIXME this causes for it to again refine???       

	if alreadyrefined: #NEW 28 Jan 2021 added to overwrite the issue caused by the below part for the case of having already refined mappings
		print "continuing with already refined mapping"
		writer[index].append(str(step))
		writer[index].append(listOfListToText(mapping))	
		filename="ex/generated_mappings/mapping_refine_1.lp"
		createMappingFile(mapping,filename,maxint,pred)
		alloccurringabatoms=[]
		cost=getCostOfMapping(test,filename,pred,interestedelts,writer,index)
		spamwriter.writerow(writer[index])
		index=index+1
		writer[index].append(realfilename)
		print cost
		if cost==0 or cost==-1:
			if cost==0:
				answer=raw_input("are you happy with the resulting abstraction? (Y/N):")   
				if answer=="N":
					mapping=computeNewMappingAskedFromUser(filename,test,mapping)  
					print mapping
					refinefocus=[[],[]]
					a=raw_input("will continue with user refinement - press enter")
					continue
			print("writing mapping to "+test+"_result")
			fout=open(test+"_result","w")
			fout.write(listOfListToText(mapping)+createMappingFile(mapping,"",maxint,pred))
			fout.close()
			print mapping
			sys.exit()
		print alloccurringabatoms
		refinefocus= countMostOccElt(alloccurringabatoms,maxint)    
		print "newrefinefocus is " + str(refinefocus[0]) + " " +str(refinefocus[1])
		
		step=step+1
		alreadyrefined=False
		continue
	
	reffocus=[[] for i in range(len(mapping))]

	for j in range(0,len(mapping)):
		print "---i'm here 0--"
		print mapping[j]
		print refinefocus
		print refinefocus[0]
		print alreadyInDiffClusters(mapping,refinefocus)
		foundafocuscluster=False
		if len(mapping[j])==1:
			print "---i'm here 4--"
			picked[j]=True
			continue
		elif alreadyInDiffClusters(mapping,refinefocus)==False and refinefocus[0] in mapping[j]:
			print "---i'm here 1--"
			foundafocuscluster=True
			randompick=j   
		elif (alreadyInDiffClusters(mapping,refinefocus) or (existsInSameCluster(mapping,refinefocus) and refinefocus[0]==refinefocus[1])) and picked[j]==False:
			print "---i'm here 2--"
			foundafocuscluster=True
			randompick=j
		else:
			print "---i'm here 3--"
			continue
		print "picking one by one"
		print mapping[randompick]
		allprintedtests=[]
		if refinetype=="0":
			refinesteps=refineGivenClusterSplit(mapping,randompick,1)
		elif refinetype=="1":
			refinesteps=refineGivenCluster(mapping,randompick,1)
		else:
			print "give a reasonable refinetype input!"
			sys.exit()


		userrefinement=False
		print refinesteps
		print "----------------------refining with 1 step----------------------"
		for i in range(0,len(refinesteps)):
			if refinesteps[i]==1:
				nopossiblesinglecluster=False
				if existsInSameCluster(allprintedtests[i],refinefocus) and refinefocus[0]!=refinefocus[1]:
					print allprintedtests[i]
					print refinefocus
					print "exists in same cluster!" 
					continue
				if makesinglecluster and someInSingleCluster(allprintedtests[i],refinefocus)==False:
					print allprintedtests[i]
					print refinefocus
					print "not in single clusters" 
					nopossiblesinglecluster=True
					continue
				

				writer[index].append(str(step))
				writer[index].append(listOfListToText(allprintedtests[i]))				

				print allprintedtests[i]
				filename="ex/generated_mappings/mapping_refine_1.lp"
				createMappingFile(allprintedtests[i],filename,maxint,pred)
				alloccurringabatoms=[]
				cost=getCostOfMapping(test,filename,pred,interestedelts,writer,index)
				
				spamwriter.writerow(writer[index])
				index=index+1
				writer[index].append(realfilename)

				
				print "cost is " + str(cost)
				if cost==0 or cost==-1:
					if cost==0:
						answer=raw_input("are you happy with the resulting abstraction? (Y/N):")   
						if answer=="N":
							mapping=computeNewMappingAskedFromUser(filename,test,mapping)  
							print mapping
							refinefocus=[[],[]]
							a=raw_input("will continue with user refinement - press enter")
							userrefinement=True
							alreadyrefined=True
							break
					print("writing mapping to "+test+"_result")
					fout=open(test+"_result","w")
					fout.write(listOfListToText(allprintedtests[i])+createMappingFile(allprintedtests[i],"",maxint,pred))
					fout.close()
					print allprintedtests[i]
					sys.exit()
                                    
				print "alloccurringabatoms"
				print alloccurringabatoms
				newrefinefocus= countMostOccElt(alloccurringabatoms,maxint)
				print "refinefocus could be " + str(newrefinefocus[0]) + " " +str(newrefinefocus[1])
				reffocus[j].append([newrefinefocus[0],newrefinefocus[1]])
					
				
				refinecosts[j].append(cost)
				allrefinements[j].append(allprintedtests[i])
		
			
		picked[randompick]=True


	if not userrefinement:
		print allrefinements
		print refinecosts
		print reffocus

		mini=[]
		for i in range(0,len(refinecosts)):
			for j in range(0,len(refinecosts[i])):
				if mini==[]:
					mini=[refinecosts[i][j], (i,j)]
				else:
					if mini[0]>refinecosts[i][j]:
						mini=[refinecosts[i][j], (i,j)]
					elif mini[0]==refinecosts[i][j]:
						mini.append((i,j))

		print mini	
		if mini==[]:
			print "no further refinement will be done"
			break		
		randompick=randint(1, len(mini)-1)
		print "picked for refinement in random "+str(randompick)
		mapping=allrefinements[mini[randompick][0]][mini[randompick][1]]
		print mapping
		refinefocus=[reffocus[mini[randompick][0]][mini[randompick][1]][0],reffocus[mini[randompick][0]][mini[randompick][1]][1]]
		print "newrefinefocus is " + str(refinefocus[0]) + " " +str(refinefocus[1])
		alreadyrefined=False

	
	step=step+1



