
import clingo
import os, sys, random

class Thing:
    def __init__(self):
        pass
    
class ModelReceiver:
  def __init__(self, interesting_atoms):
    self.displayed = 0
    self.interesting_atoms = interesting_atoms

  def __call__(self, m):

            
            # collect information about this answer set
            here = {  'interestingTrue': []}        
            here['interestingTrue'] = [ x.symbol for x in self.interesting_atoms if m.is_true(x.literal) ]
            #here['interesting'] = [x.symbol for x in m.context.symbolic_atoms.by_signature("in", 1)]# if m.is_true(x.literal)]
            #here['interesting'] += [x.symbol for x in m.context.symbolic_atoms.by_signature("out", 1)]# if m.is_true(x.literal)]
            
            self.displayed += 1
            for what in ['interestingTrue']:
              print("    {:12s} {}".format(what.upper(), repr(here[what])))

            #print("hellooo")
            #print([(m.is_true(x.literal), x.symbol) for x in m.context.symbolic_atoms.by_signature("in", 1)])
            #print([(m.is_true(x.literal), x.symbol) for x in m.context.symbolic_atoms.by_signature("out", 1)])
            #print(here['interesting'])  
            #true_non_facts = [m.context.symbolic_atoms[x].literal for x in here['interesting'] if not m.context.symbolic_atoms[x].is_fact]
            true_non_facts = [x for x in self.interesting_atoms if not m.context.symbolic_atoms[x.symbol].is_fact]
            #to_forbid = random.sample(true_non_facts, 1)
            to_forbid=true_non_facts
            print("adding nogood {} for more diversity".format(repr([(x.symbol, m.is_true(x.literal)) for x in to_forbid])))
            #m.context.add_nogood([ (x, True) for x in to_forbid ])
            m.context.add_nogood([(x.symbol, m.is_true(x.literal)) for x in to_forbid])
            
            
            #print([-lit for lit in to_forbid])
            #m.context.add_clause([-lit for lit in to_forbid])
            
            


def main():
    print clingo.__version__
    print("arguments: {}".format(repr(sys.argv[1:])))
    
    interested=sys.argv[1].split(",")
    # split into asp files and other arguments
    aspfiles = [ x for x in sys.argv[2:] if ".lp" in x or ".txt" in x]#x.endswith('.lp') ]
    clingoargs = [ x for x in sys.argv[2:] if ".lp" not in x and ".txt" not in x]#not x.endswith('.lp') ]

    # --quiet=2,2,2
    prg = clingo.Control(clingoargs)

    # load all files given in path
    for aspfile in aspfiles:
      prg.load(aspfile)

    # add cannot theory
    prg.add('base', [], """
      #theory cannot {
          t { };
          &cannot/0: t, head
      }.
      """)

    # ground
    prg.ground([("base", [])])
    
    interesting_atoms = []
    for atom in prg.symbolic_atoms:
        #print("atom {} has program literal {}".format(atom.symbol, atom.literal))
        # Jan 24' 19 : only looking at positive ones
        if atom.symbol.name in interested:# and atom.symbol.positive:#['go']:
            a = Thing()
            a.literal = atom.literal
            a.symbol = atom.symbol
            interesting_atoms.append(a)
    
    receiver = ModelReceiver(interesting_atoms)

    # get all optimal models
    prg.configuration.solve.models = 50
#    prg.configuration.solve.opt_mode = 'optN'

    prg.solve(on_model=receiver)
    print("displayed {} answer sets".format(receiver.displayed))

if __name__ == '__main__':
  main()